---
title: Accept-Charset
slug: Web/HTTP/Headers/Accept-Charset
tags:
  - Content Negotiation
  - HTTP
  - HTTP Header
  - Reference
  - Request header
---
<div>{{HTTPSidebar}}</div>

<p><span class="seoSummary">The <strong><code>Accept-Charset</code></strong> request HTTP header advertises which {{glossary("character encoding", "character encodings")}} the client understands.</span> Using <a href="/en-US/docs/Web/HTTP/Content_negotiation">content negotiation</a>, the server selects one of the encodings, uses it, and informs the client of its choice within the {{HTTPHeader("Content-Type")}} response header, usually in a <code>charset=</code> parameter. Browsers usually don't send this header, as the default value for each resource is usually correct and transmitting it would allow <a href="/en-US/docs/Mozilla/Firefox/Privacy/Tracking_Protection">fingerprinting</a>.</p>

<p>If the server cannot serve any character encoding from this request header, it can theoretically send back a {{HTTPStatus("406", "406 Not Acceptable")}} error code. But for a better user experience, this is rarely done and the <code>Accept-Charset</code> header is ignored.</p>

<div class="note">
<p>In early versions of HTTP/1.1, a default character encoding was defined: ISO-8859-1. This is no longer recommended, and now each content-type may have its own default.</p>

<p>UTF-8 is now well-supported and the overwhelmingly preferred character encoding. To <a href="https://www.eff.org/deeplinks/2010/01/primer-information-theory-and-privacy">guarantee better privacy through less configuration-based entropy</a>, all browsers omit the <code>Accept-Charset</code> header: Internet Explorer 8+, Safari 5+, Opera 11+, Firefox 10+ and Chrome 27+ no longer send it.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>yes</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Accept-Charset: &lt;charset&gt;

// Multiple types, weighted with the {{glossary("quality values", "quality value")}} syntax:
Accept-Charset: utf-8, iso-8859-1;q=0.5</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt><code><var>&lt;charset&gt;</var></code></dt>
 <dd>A character encoding name, like <code>utf-8</code> or <code>iso-8859-15.</code></dd>
 <dt><code>*</code></dt>
 <dd>Any charset not mentioned elsewhere in the header; <code>*</code> is used as a wildcard.</dd>
 <dt><code>;q=<var>&lt;weight&gt;</var></code></dt>
 <dd>Any encoding is placed in an order of preference, expressed using a relative {{glossary("quality values", "quality value")}} called the <em>weight</em>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="notranslate">Accept-Charset: iso-8859-1

Accept-Charset: utf-8, iso-8859-1;q=0.5

Accept-Charset: utf-8, iso-8859-1;q=0.5, *;q=0.1
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7231", "Accept-Charset", "5.3.3")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Context</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Accept-Charset")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>HTTP <a href="/en-US/docs/Web/HTTP/Content_negotiation">content negotiation</a></li>
 <li><a href="https://hsivonen.fi/accept-charset/">Accept-Charset is no more</a></li>
 <li>Header with the result of the content negotiation: {{HTTPHeader("Content-Type")}}</li>
 <li>Other similar headers: {{HTTPHeader("TE")}}, {{HTTPHeader("Accept-Encoding")}}, {{HTTPHeader("Accept-Language")}}, {{HTTPHeader("Accept")}}</li>
</ul>
